<template>
  <div>
    <p class="fp-settings">
      <span>{{ t(currentSettings.type) }} – {{ currentSettings.radius }} km {{ t("radius") }}</span>
      <span v-show="currentSettings.showLastRefresh && lastRefresh != null"
      >↻
        {{
          new Intl.DateTimeFormat(language, $options.refreshFormat).format(
              lastRefresh
          )
        }}
      </span>
    </p>
    <p v-if="currentSettings.apiKey.length === 0">
      {{ t("api_key_missing_text") }}
    </p>
    <p v-else-if="currentSettings.lat.length === 0 || currentSettings.lng.length === 0">
      {{ t("coordinates_missing_text") }}
    </p>
    <p v-else-if="error.length > 0">{{ error }}</p>
    <table v-else class="fp-table">
      <tr v-for="station in stations" :key="station.id">
        <td class="fp-price">
          {{
            new Intl.NumberFormat(this.language)
                .format(station.price)
                .toString()
                .slice(0, 4)
          }}<sup>{{ station.price && station.price.toString().slice(4) }}</sup>
        </td>
        <td class="fp-station">
          {{ station.brand }},&nbsp;
          <span class="fp-address"
          >{{ station.street.toLowerCase() }} {{ station.housenumber }}</span
          >
        </td>
        <td class="fp-distance">{{ station.dist }}&nbsp;km</td>
        <td class="fp-open">{{ station.isOpen ? "✓" : "✗" }}</td>
      </tr>
    </table>
  </div>
</template>

<script>
module.exports = {
  name: "fuel_prices",
  props: {
    currentSettings: {
      Type: Object,
      required: true,
    },
    currentStyles: {
      type: Object,
      required: true
    },
    records: {
      type: Array,
      required: false
    },
    language: {
      type: String,
      required: true
    },
    locale: {
      type: String,
      required: true
    },
    backendUrl: {
      type: String,
      required: true
    },
    fetchAsset: {
      type: Function,
      required: false
    }
  },
  baseUrl: "https://creativecommons.tankerkoenig.de/json",
  refreshFormat: {hour: "2-digit", minute: "2-digit"},
  data: function () {
    return {
      stations: [],
      error: "",
      lastRefresh: null
    };
  },
  locales: {
    enGb: {
      api_key_missing_text: "Please enter your tankerkoenig.de API key first.",
      coordinates_missing_text: "Please enter the coordinates"
    },
    deDe: {
      api_key_missing_text: "Bitte gib deinen API-Key von tankerkoenig.de ein.",
      coordinates_missing_text: "Bitte gib die Koordinaten ein",
      refresh_error_message: "Fehler beim Aktualisieren der Preise",
      e5: "Super E5",
      e10: "Super E10",
      diesel: "Diesel",
      radius: "Umkreis"
    },
    frFr: {
      api_key_missing_text: "Veuillez entrer votre clé API de tankerkoenig.de.",
      coordinates_missing_text: "Veuillez entrer les coordonnées",
      refresh_error_message: "Erreur de mise à jour des prix",
      e5: "E5",
      e10: "E10",
      diesel: "Gazole",
      radius: "périmètre"
    },
    esEs: {
      api_key_missing_text:
          "Por favor, introduzca su clave API de tankerkoenig.de.",
      coordinates_missing_text: "Por favor, introduzca las coordenadas",
      refresh_error_message: "Precios de actualización de errores",
      e5: "E5",
      e10: "E10",
      diesel: "Diésel",
      radius: "perimetral"
    },
    plPl: {
      api_key_missing_text: "Proszę wprowadzić klucz API z tankerkoenig.de.",
      coordinates_missing_text: "Proszę wpisać współrzędne",
      refresh_error_message: "Błąd aktualizujący ceny",
      e5: "E5",
      e10: "E10",
      diesel: "Diesel",
      radius: "obwód"
    },
    koKr: {
      api_key_missing_text: "먼저 tankerkoenig.de API 키를 입력하십시오.",
      coordinates_missing_text: "좌표를 입력하십시오.",
      refresh_error_message: "가격 새로 고침 중 오류가 발생했습니다.",
      e5: "슈퍼 E5",
      e10: "슈퍼 E10",
      diesel: "디젤",
      radius: "음 크레이스"
    }
  },
  watch: {
    currentSettings: {
      immediate: true,
      handler: function (val, oldVal) {
        if (val.apiKey.length > 0 && val.lat.length > 0 && val.lng.length > 0) {
          this.getFuelPrices();
          clearInterval(this.$options.interval);
          this.$options.interval = setInterval(this.getFuelPrices, 1800000);
        } else {
          clearInterval(this.$options.interval);
        }
      }
    }
  },
  methods: {
    getFuelPrices: async function () {
      const requestUrl = `${this.$options.baseUrl}/list.php?lat=${this.currentSettings.lat}&lng=${this.currentSettings.lng}&rad=${this.currentSettings.radius}&type=${this.currentSettings.type}&apikey=${this.currentSettings.apiKey}&sort=${this.currentSettings.sort}`;
      try {
        const body = await fetch(requestUrl).then(res => res.json());
        this.stations = body.stations.slice(0, 8);
        this.lastRefresh = Date.now();
      } catch (error) {
        if (error.response) {
          this.error = error;
        } else {
          this.error = this.$translate.text("refresh_error_message");
        }
      }
    },
    formatPrice: function (price) {
      return new Intl.NumberFormat(this.language, {
        style: "currency",
        currency: "EUR"
      }).formatToParts(station.price);
    }
  }
};
</script>
<style>
.fp-settings {
  font-size: 65%;
  margin-bottom: 1rem;
  display: flex;
  justify-content: space-between;
}

.fp-address {
  text-transform: capitalize;
  overflow: hidden;
}

.fp-table {
  table-layout: fixed;
  width: 100%;
  font-variant-numeric: tabular-nums;
}

.fp-table tr {
  vertical-align: baseline;
}

.fp-price {
  width: 12%;
}

.fp-price sup {
  font-size: 60%;
}

.fp-station {
  width: 67%;
  overflow-x: hidden;
  white-space: nowrap;
  text-overflow: ellipsis;
}

.fp-distance {
  width: 16%;
}

.fp-open {
  width: 5%;
}
</style>
